package ca.utoronto.utm.othello.model;

import javafx.scene.layout.GridPane;
import javafx.scene.layout.StackPane;
import javafx.scene.text.Text;

public abstract class OthelloController {

	protected Othello othello;
	Player player1, player2;
	StackPane view;

	public OthelloController() { }
	
	public void setView(StackPane view) {
		this.view = view;
	}
	
	public void setNextMoveView () {
		Text nextmove = (Text)this.view.getChildren().get(1);
		String s = othello.getWhosTurn() + " moves next";
		nextmove.setText(s);
	}
	
	public void setCounterView () {
		Text counter = (Text)this.view.getChildren().get(2);
		String s = OthelloBoard.P1 + ":"  + othello.getCount(OthelloBoard.P1) + " "
				+ OthelloBoard.P2 + ":" + othello.getCount(OthelloBoard.P2);
		counter.setText(s);
	}
	
	public void setWinnerView() {
		Text winner = (Text)this.view.getChildren().get(2);
		String s = othello.getWinner() + " won";
		winner.setText(s);
	}
	
	public void setModel(Othello othello) {
		this.othello = othello;
	}
	

	public void play() {
		while (!othello.isGameOver()) {
			this.report();
			
			Move move=null;
			char whosTurn = othello.getWhosTurn();
			
			if(whosTurn==OthelloBoard.P1)move = player1.getMove();
			if(whosTurn==OthelloBoard.P2)move = player2.getMove();

			this.reportMove(whosTurn, move);
			othello.move(move.getRow(), move.getCol());
		}
		this.reportFinal();
	}
	
	public void reportMove(char whosTurn, Move move) { }
	public void report() { }
	public void reportFinal() { }
}
