package ca.utoronto.utm.othello.viewcontroller;

import ca.utoronto.utm.othello.model.*;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;

public class ClickEventHandler implements EventHandler<ActionEvent> {
	
	private int row;
	private int col;
	private OthelloController controller;
	private Othello model;

	public ClickEventHandler(OthelloController controller, Othello model, int row2, int col2) {
		this.controller = controller;
		this.model = model;
		this.row = row2;
		this.col = col2;
	}

	@Override
	public void handle(ActionEvent event) {
		// make a move
		boolean ok = model.move(row, col);
//		System.out.println(ok);
		
		// report that move in the console
		// created by USER STORY 1.01
		// cancelled by USER STORY 1.02
//		Move m = new Move(row, col);
//		char turn = model.getWhosTurn();
//		controller.reportMove(turn, m);
		
		// report the board
		// created by USER STORY 1.012
		// cancelled by USER STORY 1.02
//		controller.report();
		
		// use controller to set the text
		controller.setNextMoveView();
		controller.setCounterView();
		if(this.model.isGameOver())
			controller.setWinnerView();
	}

}
