package ca.utoronto.utm.othello.viewcontroller;
import java.util.ArrayList;

import ca.utoronto.utm.othello.model.*;

import javafx.application.Application;
import javafx.collections.ObservableList;
import javafx.event.ActionEvent;
import javafx.geometry.Insets;
import javafx.scene.Node;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.TextField;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.HBox;
import javafx.scene.layout.StackPane;
import javafx.scene.layout.VBox;
import javafx.scene.text.Text;
import javafx.stage.Stage;


public class OthelloApplication extends Application {
	// REMEMBER: To run this in the lab put 
	// --module-path "/usr/share/openjfx/lib" --add-modules javafx.controls,javafx.fxml
	// in the run configuration under VM arguments.
	// You can import the JavaFX.prototype launch configuration and use it as well.
	
	@Override
	public void start(Stage stage) throws Exception {
		boolean human2humanMode = true;
		
		// Create and hook up the Model, View and the controller
		
		// CREATE A MODEL
		Othello othello = new Othello();
		
		// CREATE A CONTROLLER
		OthelloControllerHumanVSHuman controller = new OthelloControllerHumanVSHuman();
		
		// CONTROLLER->MODEL hookup
		controller.setModel(othello);
		
		// VIEW
		StackPane stack = new StackPane();
		
		GridPane grid = new GridPane();
		grid.setHgap(5);
		grid.setVgap(5);
		grid.setPadding(new Insets(64));

		// VIEW->CONTROLLER hookup
		// VIEW->MODEL hookup
		for (int row = 0; row < Othello.DIMENSION; row++) {
			for (int col = 0; col < Othello.DIMENSION; col++) {
				Button b = new Button();
				grid.add(b, col, row);
				b.setOnAction(new ClickEventHandler(controller, othello, row, col));
			}
		}
		
		stack.getChildren().add(grid);
		
		// VIEW additional elements
		Text nextMove = new Text("");
		nextMove.setTranslateX(-85);
		nextMove.setTranslateY(135);
		stack.getChildren().add(nextMove);
		
		Text counter = new Text("");
		counter.setTranslateX(0);
		counter.setTranslateY(135);
		stack.getChildren().add(counter);
		

		// CONTROLLER->VIEW hookup
		controller.setView(stack);
		
		// MODEL->VIEW hookup
		ObservableList<Node> buttons = grid.getChildren();
		othello.setButtions(buttons);
		othello.updateView();

		// SCENE
		Scene scene = new Scene(stack); 
		stage.setTitle("Othello");
		stage.setScene(scene);

		// LAUNCH THE GUI
		stage.show();
	}

	public static void main(String[] args) {
		OthelloApplication view = new OthelloApplication();
		launch(args);
	}
}
